/*
 *	Simple Linux Clustering Extensions -- List All Nodes
 *
 *	Copyright (c) 1999 Martin Mares <mj@ucw.cz>
 *		  (c) 1999 Michal Jezek <mjez6230@ss1000.ms.mff.cuni.cz>
 *		  (c) 1999 Jan Lana <jlan3028@ss1000.ms.mff.cuni.cz>
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>

#include "lib.h"

static char *states[] = { "DOWN", "IDLE", "CONN", "UP", "THIS", "DEAD" };

int
main(int argc, char **argv)
{
  ALLOCA_MSG_BUF(m, r, in_addr, sizeof(struct in_addr));
  int i;

  for(i=0;;i++)
    {
      m->to = i;
      if (slicectl(SLICE_OP_GET_NODE_STAT, m) < 0)
	{
	  if (errno == ERANGE)
	    break;
	  die("get_node_stat: %m");
	}
      printf("Node %d: %08x [%s]\n", i, ntohl(r[0].s_addr), states[m->arg]);
    }
  return 0;
}
