/*
 *	Simple Linux Clustering Extensions -- Declarations
 *
 *	Copyright (c) 1999 Martin Mares <mj@ucw.cz>
 *		  (c) 1999 Michal Jezek <mjez6230@ss1000.ms.mff.cuni.cz>
 *		  (c) 1999 Jan Lana <jlan3028@ss1000.ms.mff.cuni.cz>
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <netinet/in.h>
#include <linux/types.h>
#include <linux/slice.h>

#ifdef DEBUG
#define DBG(x, y...) printf(x, ##y)
#else
#define DBG(x, y...) do { } while(0)
#endif

/* Messages */

static inline void *init_msg_len(struct slicemsg *p, int size, void *unused)
{
  bzero(p, sizeof(struct slicemsg));
  p->length = size;
  return p->data;
}

#define ALLOCA_MSG_BYTES(p, type, q, size)				\
	struct slicemsg *p = alloca(sizeof(struct slicemsg) + (size));	\
	type *q = init_msg_len(p, size, &q)
#define ALLOCA_MSG(p, q, name) ALLOCA_MSG_BYTES(p, struct name, q, sizeof(struct name))
#define ALLOCA_MSG_BUF(p, q, name, size)						\
	struct slicemsg *p = alloca(sizeof(struct slicemsg) + (size));	\
	struct name *q = (void *) p->data

/* Utility functions */

void __attribute__((noreturn)) die(char *msg, ...);
void *xmalloc(unsigned int howmuch);
void pkt_dump(struct slicemsg *m);

/* Syscall interface */

int slicectl(int op, struct slicemsg *m);
void sm_send(struct slicemsg *m);

/* Deamon skeleton */

extern int debug, this_node;
extern int timer_period;
void main_loop(void);
void daemon_init(void);
void define_node(int n, struct in_addr *a, int this);
void mk_reply(struct slicemsg *r, struct slicemsg *m);
void mk_status(struct slicemsg *m);

int handle_pkt(struct slicemsg *m);
void handle_timer(void);

#define STATUS_REPORT_PERIOD 5
