/*
 *      Simple Linux Clustering Extensions -- Scheduler utils
 *
 *      Copyright (c) 1999 Martin Mares <mj@ucw.cz>
 *                (c) 1999 Michal Jezek <mjez6230@ss1000.ms.mff.cuni.cz>
 *                (c) 1999 Jan Lana <jlan3028@ss1000.ms.mff.cuni.cz>
 *
 *      Can be freely distributed and used under the terms of the GNU GPL.
 */

#define DEBUG_SCHED

#define FSHIFT 10       /* Number of bits of the fractional part */
#if 0
#define EXP_1S	984	/* 1/exp(1sec/25sec) */
#else
#define EXP_1S  512	/* 1024*exp(ln(1024) / (10 sec / 1 sec)) */
#endif

struct sched_status {
  unsigned int s_prior;		/* static priority - recalc when get get NODE_STATUS */
  unsigned int d_prior;		/* dynamic priority - recalc every second */
  unsigned int runs;		/* new runs on node in last second */
  unsigned int priority;	/* total priority based on the above */
};

struct node_config {
  struct in_addr addr;
  struct slice_status status;
  struct sched_status sched;
};

extern struct node_config nodes[SLICE_MAX_NODES];
extern int num_nodes;

void sched_change_stat(int node);
void sched_death(int node);
void sched_tick(void);
int sched_get_node(int who_asks);
